      program Vector_summation
	parameter (L=15000,nrep=120000)
	common/idents/idcomm,NProc,myProc   
	Dimension V(L)    ! Vector and its length
	integer v,s,s1,t,summ
      Include 'mpif.h'
      integer status(MPI_Status_Size)     
      character*2 suffix/'es'/
      if(myProc.eq.0) then  ! Initalisation is performed only by master!
 	  do i=1,L
	     v(i)=i           ! to know the correct result=L*(L+1)/2
        enddo
      endif
!
      idcomm=MPI_Comm_World 
      call MPI_Init(ierr)                         ! Standard start of any MPI-program
      call MPI_Comm_Size(idcomm, NProc, ierr)     ! How many processes are there ?
      call MPI_Comm_Rank(idcomm, myProc, ierr)    ! Who am I ?
      if(myProc.eq.0) then
	  if(NProc.eq.1) suffix=''
        write(*,*) 'Summation for vector of length',L
        write(*,*) 'Parallel version running by',NProc,' process',suffix
      endif
	call MPI_BCast(v,L,MPI_Integer, 0, idcomm,ierr)  ! propagate V to all processes
        
	call profile_start  ! start timing
	do irep=1,nrep      ! to make computations more heavy
      	t=0
	    do i=1+myProc,L,NProc
	      t=t+v(i)
	    enddo
	enddo
      call profile_fin                      ! end timing

      if(myProc.ne.0) then   ! send  own partial sum to master-process
         call MPI_Send(t,1,MPI_Integer, 0, 0,idcomm,ierr)
	else                   ! master receives all partial summ and summates them
        summ=t               ! calculated by master itself! 
	  do j=2,NProc
	    call MPI_Recv(t,1,MPI_Integer, j-1, 0,idcomm,status,ierr)
	    summ=summ+t
        enddo
      endif
      if(myProc.eq.0) then
!   Final checking must be performed by master too!
	  s1=L*(L+1)/2                        ! correct result
	  if(summ.eq.s1) then                 ! and its checking
	    write(*,*) 'Correct result!'
	  else
	    write(*,*) 'Uncorrect result:',summ,'   Must be=',s1
	  endif
      endif

      call MPI_Finalize(ierr)               ! Standard finish of any MPI-program

	End
